<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <el-row>
      <el-form
        label-width="180px"
        :rules="rules"
        ref="currentData"
        class="demo-ruleForm"
        :model="currentData"
      >
        <span>Lab Information</span>
        <el-row>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('env.lab')"
              prop="lab"
            >
              <el-select
                id="lab"
                v-model="currentData.lab"
                default-first-option
                placeholder=""
                style="width:100%"
              >
                <el-option
                  v-for="item in labs"
                  :key="item.labName"
                  :label="item.labName"
                  :value="item.labName"
                />
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <span>Resource Information</span>
        <el-row>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('env.ipAddress')"
              prop="ipAddress"
            >
              <el-input
                id="ipAddress"
                v-model="currentData.ipAddress"
              />
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('user.username')"
              prop="username"
            >
              <el-input
                v-model="currentData.username"
                id="username"
              />
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('login.password')"
              prop="password"
            >
              <el-input
                v-model="currentData.password"
                id="password"
                type="password"
              />
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('env.nodeType')"
              prop="nodeType"
            >
              <el-select
                v-model="currentData.nodeType"
                style="width:100%"
                placeholder=""
              >
                <el-option
                  v-for="item in nodeType"
                  :key="item"
                  :label="item"
                  :value="item"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="'vCPUs'"
              prop="cpu"
            >
              <el-select
                id="cpus"
                v-model="currentData.cpu"
                filterable
                allow-create
                style="width:100%"
                placeholder=""
              >
                <el-option
                  v-for="item in cpus"
                  :key="item"
                  :label="item"
                  :value="item"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('env.memory')"
              prop="memory"
            >
              <el-select
                id="memory"
                v-model="currentData.memory"
                filterable
                allow-create
                style="width:100%"
                placeholder=""
              >
                <el-option
                  v-for="item in memory"
                  :key="item"
                  :label="item"
                  :value="item"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('nav.system')"
              prop="system"
            >
              <el-select
                id="memory"
                v-model="currentData.system"
                filterable
                allow-create
                placeholder=""
                style="width:100%"
              >
                <el-option
                  v-for="item in system"
                  :key="item"
                  :label="item"
                  :value="item"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('env.storage')"
              prop="storage"
            >
              <el-select
                v-model="currentData.storage"
                filterable
                allow-create
                placeholder=""
                style="width:100%"
              >
                <el-option
                  v-for="item in storageList"
                  :key="item"
                  :label="item"
                  :value="item"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              label-width="180px"
              :label="$t('env.cpuArchitacture')"
              prop="architacture"
            >
              <el-select
                id="cpuarch"
                v-model="currentData.architacture"
                placeholder=""
                style="width:100%"
              >
                <el-option
                  v-for="item in cpuArch"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('env.specialResources')"
            >
              <el-select
                id="cpuarch"
                v-model="currentData.specialResources"
                placeholder=""
                style="width:100%"
              >
                <el-option
                  v-for="item in specialRes"
                  :key="item.value"
                  :label="item.label"
                  :value="item.label"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-form-item
              :label="$t('env.remark')"
            >
              <el-input
                type="textarea"
                v-model="currentData.remarks"
                :rows="2"
              />
            </el-form-item>
          </el-col>
          <el-col
            :span="6"
          >
            <el-button
              id="batchDltBtn"
              type="primary"
              @click="submitForm('currentData')"
              style="margin-left:20px"
            >
              <em class="el-icon-correct" />
              Add
            </el-button>
          </el-col>
        </el-row>
        <el-row>
          <el-form-item
            :label="$t('env.specificationSection')"
          />
          <div class="tableDiv">
            <el-table
              :data="tableData"
              border
            >
              <el-table-column
                type="index"
                :label="$t('env.no')"
                width="50"
              />
              <el-table-column
                prop="lab"
                :label="$t('env.lab')"
              />
              <el-table-column
                prop="ipAddress"
                :label="$t('env.ipAddress')"
              />
              <el-table-column
                prop="nodeType"
                :label="$t('env.nodeType')"
              />
              <el-table-column
                prop="architacture"
                :label="$t('env.architacture')"
              />
              <el-table-column
                prop="specifications"
                :label="$t('env.specifications')"
              />
              <el-table-column
                prop="specialResources"
                :label="$t('env.specialResources')"
              />
              <el-table-column
                :label="$t('env.operation')"
                width="100"
              >
                <template slot-scope="scope">
                  <span
                    id="deleteSpecification"
                    @click="deleteSpecification(scope.row)"
                    class="el-icon-delete"
                  />
                </template>
              </el-table-column>
            </el-table>
          </div>
        </el-row>
        <el-row>
          <el-col
            :span="6"
          >
            <el-button
              id="createBtn"
              type="primary"
              style="margin-left:180px;margin-bottom:20px;"
              @click="createResources"
            >
              <em class="el-icon-ok" />
              Create
            </el-button>
          </el-col>
        </el-row>
      </el-form>
    </el-row>
  </div>
</template>
<script>
import axios from 'axios'
import { CPU_LIST, MEMORY_LIST, SYSTEM_LIST, NODE_TYPE, STORAGE_LIST, BASE_URL, CPU_ARCH, SPECIAL_RES } from '../tools/constant.js'
export default {
  name: 'Application',
  components: {
  },
  data () {
    return {
      labs: [],
      cpus: CPU_LIST,
      memory: MEMORY_LIST,
      system: SYSTEM_LIST,
      nodeType: NODE_TYPE,
      storageList: STORAGE_LIST,
      cpuArch: CPU_ARCH,
      specialRes: SPECIAL_RES,
      currentData: {
        specialResources: []
      },
      tableData: [],
      rules: {
        username: [
          { required: true, message: 'User name cannot be empty.', trigger: 'blur' },
          { pattern: /^[a-zA-Z0-9](_(?!(\.|_))|\.(?!(_|\.))|[a-zA-Z0-9]){4,18}[a-zA-Z0-9]$/, message: 'Only latters, numbers, minimum 6 characters' }
        ],
        password: [
          { required: true, message: 'Password cannot be empty.', trigger: 'blur' },
          { pattern: /^(?=.*\d)(?=.*[!@#$%^&*])(?=.*[a-z])(?=.*[A-Z]).{6,16}$/, message: '6-16 digit Numbers, letters, special characters' }
        ],
        nodeType: [
          { required: true, message: 'Node Type can not be empty.', trigger: 'blur' }
        ],
        storage: [
          { required: true, message: 'Storage can not be empty.', trigger: 'blur' }
        ],
        architacture: [
          { required: true, message: 'Architacture can not be empty.', trigger: 'blur' }
        ],
        ipAddress: [
          { required: true, message: 'IP address cannot be empty.', trigger: 'blur' },
          { pattern: /^((25[0-5]|(2[0-4]|1[0-9]|[1-9]|)[0-9])(\.(?!$)|$)){4}$/, message: 'IP address not valid.' }
        ],
        system: [
          { required: true, message: 'System can not be empty', trigger: 'blur' }
        ],
        lab: [
          { required: true, message: 'Lab can not be empty', trigger: 'blur' }
        ],
        memory: [
          { required: true, message: 'Memory can not be empty', trigger: 'blur' }
        ],
        cpu: [
          { required: true, message: 'CPUs can not be empty', trigger: 'blur' }
        ],
        specialResources: [
          { required: true, message: 'Specific selection can not be empty', trigger: 'blur' }
        ]
      }
    }
  },
  mounted () {
    this.getLabs()
  },
  computed: {
  },
  methods: {
    submitForm (formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.addSpecifications()
          this.$refs[formName].resetFields()
        } else {
          console.log('error submit!!')
          return false
        }
      })
    },
    resetForm (formName) {
      this.$refs[formName].resetFields()
    },
    addSpecifications () {
      let specific = `${this.currentData.cpu} | ${this.currentData.memory} | ${this.currentData.system}`
      this.currentData.specialResources = this.currentData.specialResources.toString()
      this.currentData['specifications'] = specific
      let d = JSON.stringify(this.currentData)
      this.tableData.push(JSON.parse(d))
    },
    async createResources () {
      if (this.tableData.length === 0) {
        this.$parent.$parent.errorMessage('Please add atleast one resource before create.')
        return
      }
      let addData = {
        'userId': sessionStorage.getItem('userId'),
        'resourceList': this.tableData
      }
      let url = BASE_URL + '/addResource'
      axios({
        method: 'POST',
        url: url,
        data: addData,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.currentData = {}
        this.tableData = []
        this.$emit('cancelDialog', true)
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    async getLabs (data) {
      let url = BASE_URL + '/getLab'
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.labs = res.data
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    }
  }
}
</script>
<style lang='less' scoped>
.tableDiv {
  width:80%;
  margin-left: 10%;
  margin-bottom: 1%;
}
</style>
